Index: /LMDZ5/branches/testing/libf/phylmd/alpale.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/alpale.F90	(revision 2542)
+++ /LMDZ5/branches/testing/libf/phylmd/alpale.F90	(revision 2542)
@@ -0,0 +1,197 @@
+SUBROUTINE alpale ( debut, itap, dtime, paprs, omega, t_seri,   &
+                    alp_offset, it_wape_prescr,  wape_prescr, fip_prescr, &
+                    ale_bl_prescr, alp_bl_prescr, &
+                    wake_pe, wake_fip,  &
+                    Ale_bl, Ale_bl_trig, Alp_bl, &
+                    Ale, Alp )
+
+! **************************************************************
+! *
+! ALPALE                                                       *
+! *
+! *
+! written by   : Jean-Yves Grandpeix, 12/05/2016              *
+! modified by :                                               *
+! **************************************************************
+
+  USE dimphy
+  USE ioipsl_getin_p_mod, ONLY : getin_p
+  USE print_control_mod, ONLY: mydebug=>debug , lunout, prt_level
+  USE phys_local_var_mod, ONLY: zw2       ! Variables internes non sauvegardees de la physique
+!
+  IMPLICIT NONE
+
+!================================================================
+! Auteur(s)   : Jean-Yves Grandpeix, 12/05/2016
+! Objet : Sums up all contributions to Ale and Alp
+!================================================================
+
+! Input arguments
+!----------------
+  LOGICAL, INTENT(IN)                                        :: debut
+  INTEGER, INTENT(IN)                                        :: itap
+  REAL, INTENT(IN)                                           :: dtime
+  INTEGER, INTENT(IN)                                        :: it_wape_prescr
+  REAL, INTENT(IN)                                           :: wape_prescr, fip_prescr
+  REAL, INTENT(IN)                                           :: Ale_bl_prescr, Alp_bl_prescr
+  REAL, INTENT(IN)                                           :: alp_offset
+  REAL, DIMENSION(klon,klev+1), INTENT(IN)                   :: paprs
+  REAL, DIMENSION(klon,klev), INTENT(IN)                     :: t_seri
+  REAL, DIMENSION(klon,klev), INTENT(IN)                     :: omega
+  REAL, DIMENSION(klon), INTENT(IN)                          :: wake_pe, wake_fip
+  REAL, DIMENSION(klon), INTENT(IN)                          :: Ale_bl, Ale_bl_trig, Alp_bl
+
+
+! Output arguments
+!----------------
+  REAL, DIMENSION(klon), INTENT(OUT)                         :: Ale, Alp
+
+  include "thermcell.h"
+  include "YOMCST.h"
+  include "YOETHF.h"
+
+! Local variables
+!----------------
+  INTEGER                                                    :: i, k
+  REAL, DIMENSION(klon)                                      :: www
+  REAL, DIMENSION(klon)                                      :: ale_wake, alp_wake
+  REAL, SAVE                                                 :: ale_max=1000.
+  REAL, SAVE                                                 :: alp_max=2.
+  CHARACTER*20 modname
+  CHARACTER*80 abort_message
+
+
+    !$OMP THREADPRIVATE(ale_max,alp_max)
+
+       ! Calcul de l'energie disponible ALE (J/kg) et de la puissance
+       ! disponible ALP (W/m2) pour le soulevement des particules dans
+       ! le modele convectif
+       !
+       do i = 1,klon
+          ALE(i) = 0.
+          ALP(i) = 0.
+       enddo
+       !
+       !calcul de ale_wake et alp_wake
+       if (iflag_wake>=1) then
+          if (itap .le. it_wape_prescr) then
+             do i = 1,klon
+                ale_wake(i) = wape_prescr
+                alp_wake(i) = fip_prescr
+             enddo
+          else
+             do i = 1,klon
+                !jyg  ALE=WAPE au lieu de ALE = 1/2 Cstar**2
+                !cc           ale_wake(i) = 0.5*wake_cstar(i)**2
+                ale_wake(i) = wake_pe(i)
+                alp_wake(i) = wake_fip(i)
+             enddo
+          endif
+       else
+          do i = 1,klon
+             ale_wake(i) = 0.
+             alp_wake(i) = 0.
+          enddo
+       endif
+       !combinaison avec ale et alp de couche limite: constantes si pas
+       !de couplage, valeurs calculees dans le thermique sinon
+       if (iflag_coupl.eq.0) then
+          if (debut.and.prt_level.gt.9) &
+               WRITE(lunout,*)'ALE et ALP imposes'
+          do i = 1,klon
+             !on ne couple que ale
+             !           ALE(i) = max(ale_wake(i),Ale_bl(i))
+             ALE(i) = max(ale_wake(i),ale_bl_prescr)
+             !on ne couple que alp
+             !           ALP(i) = alp_wake(i) + Alp_bl(i)
+             ALP(i) = alp_wake(i) + alp_bl_prescr
+          enddo
+       else
+          IF(prt_level>9)WRITE(lunout,*)'ALE et ALP couples au thermique'
+          !         do i = 1,klon
+          !             ALE(i) = max(ale_wake(i),Ale_bl(i))
+          ! avant        ALP(i) = alp_wake(i) + Alp_bl(i)
+          !             ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
+          !         write(20,*)'ALE',ALE(i),Ale_bl(i),ale_wake(i)
+          !         write(21,*)'ALP',ALP(i),Alp_bl(i),alp_wake(i)
+          !         enddo
+
+          ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+          ! Modif FH 2010/04/27. Sans doute temporaire.
+          ! Deux options pour le alp_offset : constant si >?? 0 ou
+          ! proportionnel ??a w si <0
+          ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+          ! Estimation d'une vitesse verticale effective pour ALP
+          if (1==0) THEN
+             www(1:klon)=0.
+             do k=2,klev-1
+                do i=1,klon
+                   www(i)=max(www(i),-omega(i,k)*RD*t_seri(i,k) &
+                        /(RG*paprs(i,k)) *zw2(i,k)*zw2(i,k))
+                   ! if (paprs(i,k)>pbase(i)) then
+                   ! calcul approche de la vitesse verticale en m/s
+                   !  www(i)=max(www(i),-omega(i,k)*RD*temp(i,k)/(RG*paprs(i,k))
+                   !             endif
+                   !   Le 0.1 est en gros H / ps = 1e4 / 1e5
+                enddo
+             enddo
+             do i=1,klon
+                if (www(i)>0. .and. ale_bl(i)>0. ) www(i)=www(i)/ale_bl(i)
+             enddo
+          ENDIF
+
+
+          do i = 1,klon
+             ALE(i) = max(ale_wake(i),Ale_bl(i))
+             !cc nrlmd le 10/04/2012----------Stochastic triggering------------
+             if (iflag_trig_bl.ge.1) then
+                ALE(i) = max(ale_wake(i),Ale_bl_trig(i))
+             endif
+             !cc fin nrlmd le 10/04/2012
+             if (alp_offset>=0.) then
+                ALP(i) = alp_wake(i) + Alp_bl(i) + alp_offset ! modif sb
+             else
+                abort_message ='Ne pas passer la car www non calcule'
+                CALL abort_physic (modname,abort_message,1)
+
+                ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+                !                                _                  _
+                ! Ajout d'une composante 3 * A * w w'2 a w'3 avec
+                ! w=www : w max sous pbase ou A est la fraction
+                ! couverte par les ascendances w' on utilise le fait
+                ! que A * w'3 = ALP et donc A * w'2 ~ ALP / sqrt(ALE)
+                ! (on ajoute 0.1 pour les singularites)
+                ALP(i)=alp_wake(i)*(1.+3.*www(i)/( sqrt(ale_wake(i))+0.1) ) &
+                     +alp_bl(i)  *(1.+3.*www(i)/( sqrt(ale_bl(i))  +0.1) )
+                !    ALP(i)=alp_wake(i)+Alp_bl(i)+alp_offset*min(omega(i,6),0.)
+                !             if (alp(i)<0.) then
+                !                print*,'ALP ',alp(i),alp_wake(i) &
+                !                     ,Alp_bl(i),alp_offset*min(omega(i,6),0.)
+                !             endif
+             endif
+          enddo
+          ! !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
+       endif
+       do i=1,klon
+          if (alp(i)>alp_max) then
+             IF(prt_level>9)WRITE(lunout,*)                             &
+                  'WARNING SUPER ALP (seuil=',alp_max, &
+                  '): i, alp, alp_wake,ale',i,alp(i),alp_wake(i),ale(i)
+             alp(i)=alp_max
+          endif
+          if (ale(i)>ale_max) then
+             IF(prt_level>9)WRITE(lunout,*)                             &
+                  'WARNING SUPER ALE (seuil=',ale_max, &
+                  '): i, alp, alp_wake,ale',i,ale(i),ale_wake(i),alp(i)
+             ale(i)=ale_max
+          endif
+       enddo
+
+       !fin calcul ale et alp
+       !=======================================================================
+
+
+  RETURN
+  END
+
Index: /LMDZ5/branches/testing/libf/phylmd/alpale_th.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/alpale_th.F90	(revision 2542)
+++ /LMDZ5/branches/testing/libf/phylmd/alpale_th.F90	(revision 2542)
@@ -0,0 +1,186 @@
+SUBROUTINE alpale_th ( dtime, lmax_th, t_seri,  &
+                       cin, s2, n2,  &
+                       ale_bl_trig, ale_bl_stat, ale_bl,  &
+                       alp_bl, alp_bl_stat )
+
+! **************************************************************
+! *
+! ALPALE_TH                                                    *
+! *
+! *
+! written by   : Jean-Yves Grandpeix, 11/05/2016              *
+! modified by :                                               *
+! **************************************************************
+
+  USE dimphy
+  USE ioipsl_getin_p_mod, ONLY : getin_p
+  USE print_control_mod, ONLY: mydebug=>debug , lunout, prt_level
+!
+  IMPLICIT NONE
+
+!================================================================
+! Auteur(s)   : Jean-Yves Grandpeix, 11/05/2016
+! Objet : Contribution of the thermal scheme to Ale and Alp
+!================================================================
+
+! Input arguments
+!----------------
+  REAL, INTENT(IN)                                           :: dtime
+  INTEGER, DIMENSION(klon), INTENT(IN)                       :: lmax_th
+  REAL, DIMENSION(klon,klev), INTENT(IN)                     :: t_seri
+  REAL, DIMENSION(klon), INTENT(IN)                          :: ale_bl_stat
+  REAL, DIMENSION(klon), INTENT(IN)                          :: cin
+  REAL, DIMENSION(klon), INTENT(IN)                          :: s2, n2
+                                                                
+  REAL, DIMENSION(klon), INTENT(INOUT)                       :: ale_bl_trig, ale_bl
+  REAL, DIMENSION(klon), INTENT(INOUT)                       :: alp_bl
+  REAL, DIMENSION(klon), INTENT(INOUT)                       :: alp_bl_stat
+
+  include "thermcell.h"
+
+! Local variables
+!----------------
+  INTEGER                                                    :: i
+  LOGICAL, SAVE                                              :: first = .TRUE.
+  REAL, SAVE                                                 :: random_notrig_max=1.
+  REAL, DIMENSION(klon)                                      :: proba_notrig, tau_trig, random_notrig
+!
+    !$OMP THREADPRIVATE(random_notrig_max) 
+    !$OMP THREADPRIVATE(first)
+!
+    IF (first) THEN
+       CALL getin_p('random_notrig_max',random_notrig_max)
+       first=.FALSE.
+    ENDIF
+          !cc nrlmd le 10/04/2012
+          !-----------Stochastic triggering-----------
+          if (iflag_trig_bl.ge.1) then
+             !
+             IF (prt_level .GE. 10) THEN
+                print *,'cin, ale_bl_stat, alp_bl_stat ', &
+                     cin, ale_bl_stat, alp_bl_stat
+             ENDIF
+
+
+             !----Initialisations
+             do i=1,klon
+                proba_notrig(i)=1.
+                random_notrig(i)=1e6*ale_bl_stat(i)-int(1e6*ale_bl_stat(i))
+                if ( random_notrig(i) > random_notrig_max ) random_notrig(i)=0.
+                if ( ale_bl_trig(i) .lt. abs(cin(i))+1.e-10 ) then 
+                   tau_trig(i)=tau_trig_shallow
+                else
+                   tau_trig(i)=tau_trig_deep
+                endif
+             enddo
+             !
+             IF (prt_level .GE. 10) THEN
+                print *,'random_notrig, tau_trig ', &
+                     random_notrig, tau_trig
+                print *,'s_trig,s2,n2 ', &
+                     s_trig,s2,n2
+             ENDIF
+
+             !Option pour re-activer l'ancien calcul de Ale_bl (iflag_trig_bl=2)
+             IF (iflag_trig_bl.eq.1) then
+
+                !----Tirage al\'eatoire et calcul de ale_bl_trig
+                do i=1,klon
+                   if ( (ale_bl_stat(i) .gt. abs(cin(i))+1.e-10) )  then
+                      proba_notrig(i)=(1.-exp(-s_trig/s2(i)))** &
+                           (n2(i)*dtime/tau_trig(i))
+                      !        print *, 'proba_notrig(i) ',proba_notrig(i)
+                      if (random_notrig(i) .ge. proba_notrig(i)) then 
+                         ale_bl_trig(i)=ale_bl_stat(i)
+                      else
+                         ale_bl_trig(i)=0.
+                      endif
+                   else
+                      proba_notrig(i)=1.
+                      random_notrig(i)=0.
+                      ale_bl_trig(i)=0.
+                   endif
+                enddo
+
+             ELSE IF (iflag_trig_bl.ge.2) then
+
+                do i=1,klon
+                   if ( (Ale_bl(i) .gt. abs(cin(i))+1.e-10) )  then
+                      proba_notrig(i)=(1.-exp(-s_trig/s2(i)))** &
+                           (n2(i)*dtime/tau_trig(i))
+                      !        print *, 'proba_notrig(i) ',proba_notrig(i)
+                      if (random_notrig(i) .ge. proba_notrig(i)) then 
+                         ale_bl_trig(i)=Ale_bl(i)
+                      else
+                         ale_bl_trig(i)=0.
+                      endif
+                   else
+                      proba_notrig(i)=1.
+                      random_notrig(i)=0.
+                      ale_bl_trig(i)=0.
+                   endif
+                enddo
+
+             ENDIF
+
+             !
+             IF (prt_level .GE. 10) THEN
+                print *,'proba_notrig, ale_bl_trig ', &
+                     proba_notrig, ale_bl_trig
+             ENDIF
+
+          endif !(iflag_trig_bl)
+
+          !-----------Statistical closure-----------
+          if (iflag_clos_bl.eq.1) then 
+
+             do i=1,klon
+                !CR: alp probabiliste
+                if (ale_bl_trig(i).gt.0.) then
+                   alp_bl(i)=alp_bl(i)/(1.-min(proba_notrig(i),0.999))
+                endif
+             enddo
+
+          else if (iflag_clos_bl.eq.2) then
+
+             !CR: alp calculee dans thermcell_main
+             do i=1,klon
+                alp_bl(i)=alp_bl_stat(i)
+             enddo
+
+          else
+
+             alp_bl_stat(:)=0.
+
+          endif !(iflag_clos_bl)
+
+          IF (prt_level .GE. 10) THEN
+             print *,'ale_bl_trig, alp_bl_stat ',ale_bl_trig, alp_bl_stat
+          ENDIF
+
+          !cc fin nrlmd le 10/04/2012
+
+          ! ------------------------------------------------------------------
+          ! Transport de la TKE par les panaches thermiques.
+          ! FH : 2010/02/01
+          !     if (iflag_pbl.eq.10) then
+          !     call thermcell_dtke(klon,klev,nbsrf,pdtphys,fm_therm,entr_therm,
+          !    s           rg,paprs,pbl_tke)
+          !     endif
+          ! -------------------------------------------------------------------
+          !IM/FH: 2011/02/23 
+          ! Couplage Thermiques/Emanuel seulement si T<0
+          if (iflag_coupl==2) then
+             IF (prt_level .GE. 10) THEN
+                print*,'Couplage Thermiques/Emanuel seulement si T<0'
+             ENDIF
+             do i=1,klon
+                if (t_seri(i,lmax_th(i))>273.) then
+                   Ale_bl(i)=0.
+                endif
+             enddo
+          endif
+!
+   RETURN
+   END
+
Index: /LMDZ5/branches/testing/libf/phylmd/calcratqs.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/calcratqs.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/calcratqs.F90	(revision 2542)
@@ -1,5 +1,6 @@
 SUBROUTINE calcratqs(klon,klev,prt_level,lunout,       &
            iflag_ratqs,iflag_con,iflag_cld_th,pdtphys, &
-           ratqsbas,ratqshaut,tau_ratqs,fact_cldcon,   &
+           ratqsbas,ratqshaut,ratqsp0,ratqsdp, &
+           tau_ratqs,fact_cldcon,   &
            ptconv,ptconvth,clwcon0th, rnebcon0th,      &
            paprs,pplay,q_seri,zqsat,fm_therm,          &
@@ -21,4 +22,5 @@
 integer,intent(in) :: iflag_con,iflag_cld_th,iflag_ratqs
 real,intent(in) :: pdtphys,ratqsbas,ratqshaut,fact_cldcon,tau_ratqs
+real,intent(in) :: ratqsp0, ratqsdp
 real, dimension(klon,klev+1),intent(in) :: paprs
 real, dimension(klon,klev),intent(in) :: pplay,q_seri,zqsat,fm_therm
@@ -125,5 +127,6 @@
          do k=1,klev
            ratqss(:,k)=ratqsbas+0.5*(ratqshaut-ratqsbas) &
-           *( tanh( (50000.-pplay(:,k))/20000.) + 1.)
+!          *( tanh( (50000.-pplay(:,k))/20000.) + 1.)
+           *( tanh( (ratqsp0-pplay(:,k))/ratqsdp) + 1.)
          enddo
 
Index: /LMDZ5/branches/testing/libf/phylmd/calcul_fluxs_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/calcul_fluxs_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/calcul_fluxs_mod.F90	(revision 2542)
@@ -1,2 +1,4 @@
+!
+! $Id$
 !
 MODULE calcul_fluxs_mod
@@ -9,5 +11,7 @@
        radsol, dif_grnd, t1lay, q1lay, u1lay, v1lay, gustiness, &
        fqsat, petAcoef, peqAcoef, petBcoef, peqBcoef, &
-       tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l)
+       tsurf_new, evap, fluxlat, fluxsens, dflux_s, dflux_l, &
+       sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
+ 
     
     USE dimphy, ONLY : klon
@@ -49,5 +53,8 @@
 !   dflux_s      derivee du flux de chaleur sensible / Ts
 !   dflux_l      derivee du flux de chaleur latente  / Ts
-!
+!   sens_prec_liq flux sensible lié aux echanges de precipitations liquides
+!   sens_prec_sol                                    precipitations solides
+!   lat_prec_liq  flux latent lié aux echanges de precipitations liquides
+!   lat_prec_sol                                  precipitations solides
 
     INCLUDE "YOETHF.h"
@@ -77,4 +84,6 @@
     REAL, DIMENSION(klon), INTENT(OUT)   :: tsurf_new, evap, fluxsens, fluxlat
     REAL, DIMENSION(klon), INTENT(OUT)   :: dflux_s, dflux_l
+    REAL, DIMENSION(klon), OPTIONAL      :: sens_prec_liq, sens_prec_sol
+    REAL, DIMENSION(klon), OPTIONAL      :: lat_prec_liq, lat_prec_sol
 
 ! Variables locales
@@ -130,4 +139,8 @@
     dflux_s = 0.
     dflux_l = 0.
+    if (PRESENT(sens_prec_liq)) sens_prec_liq = 0.
+    if (PRESENT(sens_prec_sol)) sens_prec_sol = 0.
+    if (PRESENT(lat_prec_liq)) lat_prec_liq = 0.
+    if (PRESENT(lat_prec_sol)) lat_prec_sol = 0.
 !
 ! zx_qs = qsat en kg/kg
@@ -243,5 +256,34 @@
 !!$     &  run_off(i) = run_off(i) + max(qsol(i) - max_eau_sol, 0.0)
 !!$    qsol(i) = min(qsol(i), max_eau_sol) 
+!
+! calcul de l'enthalpie des precipitations liquides et solides
+!
+!       if (PRESENT(enth_prec_liq))                   &
+!       enth_prec_liq(i) = rcw * (t1lay(i) - tsurf(i)) * &
+!                          precip_rain(i)
+!       if (PRESENT(enth_prec_sol))                  &
+!       enth_prec_sol(i) = rcs * (t1lay(i) - tsurf(i)) * &
+!                          precip_snow(i)
+! On calcule par rapport a T=0
+       if (PRESENT(sens_prec_liq))                   &
+         sens_prec_liq(i) = rcw * (t1lay(i) - RTT) * &
+                          precip_rain(i)
+       if (PRESENT(sens_prec_sol))                   &
+         sens_prec_sol(i) = rcs * (t1lay(i) - RTT) * &
+                          precip_snow(i)
+       if (PRESENT(lat_prec_liq))                    &
+         lat_prec_liq(i) =  precip_rain(i) * (RLVTT - RLVTT) 
+       if (PRESENT(lat_prec_sol))                    &
+         lat_prec_sol(i) = precip_snow(i) * (RLSTT - RLVTT)
     ENDDO
+
+    
+!       if (PRESENT(sens_prec_liq))                  &
+!          WRITE(*,*)' calculs_fluxs sens_prec_liq (min, max)', &
+!          MINVAL(sens_prec_liq(1:knon)), MAXVAL(sens_prec_liq(1:knon))
+!       if (PRESENT(sens_prec_sol))                  &
+!          WRITE(*,*)' calculs_fluxs sens_prec_sol (min, max)', &
+!          MINVAL(sens_prec_sol(1:knon)), MAXVAL(sens_prec_sol(1:knon))
+ 
 !
 !****************************************************************************************
Index: /LMDZ5/branches/testing/libf/phylmd/clesphys.h
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/clesphys.h	(revision 2542)
@@ -15,4 +15,5 @@
        INTEGER nbapp_rad, iflag_con,iflag_ener_conserv
        REAL co2_ppm, co2_ppm0, solaire
+       LOGICAL ok_suntime_rrtm
        REAL(kind=8) RCO2, RCH4, RN2O, RCFC11, RCFC12  
        REAL(kind=8) RCO2_act, RCH4_act, RN2O_act, RCFC11_act, RCFC12_act  
@@ -110,7 +111,8 @@
      &     , top_height                                                 &
      &     , cycle_diurne, soil_model, new_oliq                         &
-     &     ,ok_orodr, ok_orolf, ok_limitvrai, nbapp_rad, iflag_con      &
+     &     , ok_orodr, ok_orolf, ok_limitvrai, nbapp_rad, iflag_con     &
      &     , iflag_ener_conserv                                         &
      &     , ok_4xCO2atm                                                & 
+     &     , ok_suntime_rrtm                                            & 
      &     , overlap                                                    &
      &     , ok_kzmin                                                   &
@@ -129,3 +131,2 @@
        save /clesphys/
 !$OMP THREADPRIVATE(/clesphys/)
- 
Index: /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/conf_phys_m.F90	(revision 2542)
@@ -76,5 +76,5 @@
     LOGICAL              :: ok_ade, ok_aie, ok_cdnc, aerosol_couple
     INTEGER              :: flag_aerosol
-    LOGICAL              :: flag_aerosol_strat
+    INTEGER              :: flag_aerosol_strat
     LOGICAL              :: new_aod
     REAL                 :: bl95_b0, bl95_b1
@@ -94,5 +94,5 @@
     LOGICAL,SAVE        :: ok_ade_omp, ok_aie_omp, ok_cdnc_omp, aerosol_couple_omp
     INTEGER, SAVE       :: flag_aerosol_omp
-    LOGICAL, SAVE       :: flag_aerosol_strat_omp
+    INTEGER, SAVE       :: flag_aerosol_strat_omp
     LOGICAL, SAVE       :: new_aod_omp
     REAL,SAVE           :: bl95_b0_omp, bl95_b1_omp
@@ -148,4 +148,5 @@
 
     REAL,SAVE :: R_ecc_omp,R_peri_omp,R_incl_omp,solaire_omp
+    LOGICAL,SAVE :: ok_suntime_rrtm_omp
     REAL,SAVE :: co2_ppm_omp, RCO2_omp, co2_ppm_per_omp, RCO2_per_omp
     REAL,SAVE :: CH4_ppb_omp, RCH4_omp, CH4_ppb_per_omp, RCH4_per_omp
@@ -385,10 +386,13 @@
     !
     !Config Key  = flag_aerosol_strat
-    !Config Desc = use stratospheric aerosols T/F
-    !Config Def  = false
+    !Config Desc = use stratospheric aerosols 0, 1, 2
+    ! - 0 = no stratospheric aerosols 
+    ! - 1 = stratospheric aerosols scaled from 550 nm AOD 
+    ! - 2 = stratospheric aerosol properties from CMIP6
+    !Config Def  = 0
     !Config Help = Used in physiq.F
     !
     !
-    flag_aerosol_strat_omp = .false.
+    flag_aerosol_strat_omp = 0
     CALL getin('flag_aerosol_strat',flag_aerosol_strat_omp)
 
@@ -514,4 +518,14 @@
     solaire_omp = 1365.
     call getin('solaire', solaire_omp)
+    !
+    !Config Key  = ok_sun_time
+    !Config Desc = oui ou non variabilite solaire
+    !Config Def  = .false.
+    !Config Help =
+    !
+    !
+    !valeur AMIP II
+    ok_suntime_rrtm_omp = .false.
+    call getin('ok_suntime_rrtm',ok_suntime_rrtm_omp)
     !
     !Config Key  = co2_ppm
@@ -1967,4 +1981,5 @@
     R_incl = R_incl_omp
     solaire = solaire_omp
+    ok_suntime_rrtm = ok_suntime_rrtm_omp
     co2_ppm = co2_ppm_omp
     RCO2 = RCO2_omp
@@ -2281,4 +2296,5 @@
     write(lunout,*)' Inclinaison =',R_incl
     write(lunout,*)' Constante solaire =',solaire
+    write(lunout,*)' ok_suntime_rrtm =',ok_suntime_rrtm
     write(lunout,*)' co2_ppm =',co2_ppm
     write(lunout,*)' RCO2_act = ',RCO2_act
Index: /LMDZ5/branches/testing/libf/phylmd/cpl_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cpl_mod.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/cpl_mod.F90	(revision 2542)
@@ -52,4 +52,6 @@
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_windsp
   !$OMP THREADPRIVATE(cpl_windsp)
+  REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_sens_rain, cpl_sens_snow
+  !$OMP THREADPRIVATE(cpl_sens_rain, cpl_sens_snow)
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_taumod
   !$OMP THREADPRIVATE(cpl_taumod)
@@ -90,4 +92,6 @@
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_windsp2D
   !$OMP THREADPRIVATE(cpl_windsp2D)
+  REAL, ALLOCATABLE, DIMENSION(:,:,:), SAVE   :: cpl_sens_rain2D, cpl_sens_snow2D
+  !$OMP THREADPRIVATE(cpl_sens_rain2D, cpl_sens_snow2D)
   REAL, ALLOCATABLE, DIMENSION(:,:), SAVE   :: cpl_atm_co22D
   !$OMP THREADPRIVATE(cpl_atm_co22D)
@@ -168,5 +172,7 @@
     ALLOCATE(cpl_windsp(klon,2), stat = error)
     sum_error = sum_error + error
-    ALLOCATE(cpl_taumod(klon,2), stat = error)
+    ALLOCATE(cpl_sens_rain(klon,2), stat = error)
+    sum_error = sum_error + error
+    ALLOCATE(cpl_sens_snow(klon,2), stat = error)
     sum_error = sum_error + error
     ALLOCATE(cpl_rriv2D(nbp_lon,jj_nb), stat=error)
@@ -531,5 +537,6 @@
   SUBROUTINE cpl_send_ocean_fields(itime, knon, knindex, &
        swdown, lwdown, fluxlat, fluxsens, &
-       precip_rain, precip_snow, evap, tsurf, fder, albsol, taux, tauy, windsp)
+       precip_rain, precip_snow, evap, tsurf, fder, albsol, taux, tauy, windsp,&
+       sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
 !
 ! This subroutine cumulates some fields for each time-step during a coupling 
@@ -552,4 +559,6 @@
     REAL, DIMENSION(klon), INTENT(IN)       :: evap, tsurf, fder, albsol
     REAL, DIMENSION(klon), INTENT(IN)       :: taux, tauy, windsp
+    REAL, DIMENSION(klon), INTENT(IN)       :: sens_prec_liq, sens_prec_sol
+    REAL, DIMENSION(klon), INTENT(IN)       :: lat_prec_liq, lat_prec_sol
 
 ! Local variables
@@ -583,4 +592,6 @@
        cpl_tauy(1:knon,cpl_index) = 0.0
        cpl_windsp(1:knon,cpl_index) = 0.0
+       cpl_sens_rain(1:knon,cpl_index) = 0.0
+       cpl_sens_snow(1:knon,cpl_index) = 0.0
        cpl_taumod(1:knon,cpl_index) = 0.0
        IF (carbon_cycle_cpl) cpl_atm_co2(1:knon,cpl_index) = 0.0
@@ -614,4 +625,8 @@
        cpl_windsp(ig,cpl_index) = cpl_windsp(ig,cpl_index) + &
             windsp(ig)      / REAL(nexca)
+       cpl_sens_rain(ig,cpl_index) = cpl_sens_rain(ig,cpl_index) + &
+            sens_prec_liq(ig)      / REAL(nexca)
+       cpl_sens_snow(ig,cpl_index) = cpl_sens_snow(ig,cpl_index) + &
+            sens_prec_sol(ig)      / REAL(nexca)
        cpl_taumod(ig,cpl_index) =   cpl_taumod(ig,cpl_index) + &
           SQRT ( taux(ig)*taux(ig)+tauy(ig)*tauy(ig) ) / REAL (nexca)
@@ -654,4 +669,8 @@
           sum_error = sum_error + error
           ALLOCATE(cpl_windsp2D(nbp_lon,jj_nb), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_sens_rain2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_sens_snow2D(nbp_lon,jj_nb,2), stat=error)
           sum_error = sum_error + error
           ALLOCATE(cpl_taumod2D(nbp_lon,jj_nb,2), stat=error)
@@ -706,4 +725,10 @@
             knon, knindex)
 
+       CALL gath2cpl(cpl_sens_rain(:,cpl_index), cpl_sens_rain2D(:,:,cpl_index), &
+            knon, knindex)
+
+       CALL gath2cpl(cpl_sens_snow(:,cpl_index), cpl_sens_snow2D(:,:,cpl_index), &
+            knon, knindex)
+
        CALL gath2cpl(cpl_taumod(:,cpl_index), cpl_taumod2D(:,:,cpl_index), &
             knon, knindex)
@@ -722,5 +747,6 @@
        pctsrf, lafin, rlon, rlat, &
        swdown, lwdown, fluxlat, fluxsens, &
-       precip_rain, precip_snow, evap, tsurf, fder, albsol, taux, tauy)
+       precip_rain, precip_snow, evap, tsurf, fder, albsol, taux, tauy,&
+       sens_prec_liq, sens_prec_sol, lat_prec_liq, lat_prec_sol)
 !
 ! This subroutine cumulates some fields for each time-step during a coupling 
@@ -746,4 +772,6 @@
     REAL, DIMENSION(klon), INTENT(IN)       :: albsol, taux, tauy
     REAL, DIMENSION(klon,nbsrf), INTENT(IN) :: pctsrf
+    REAL, DIMENSION(klon), INTENT(IN)       :: sens_prec_liq, sens_prec_sol
+    REAL, DIMENSION(klon), INTENT(IN)       :: lat_prec_liq, lat_prec_sol
     LOGICAL, INTENT(IN)                     :: lafin
 
@@ -778,4 +806,6 @@
        cpl_taux(1:knon,cpl_index) = 0.0
        cpl_tauy(1:knon,cpl_index) = 0.0
+       cpl_sens_rain(1:knon,cpl_index) = 0.0
+       cpl_sens_snow(1:knon,cpl_index) = 0.0
        cpl_taumod(1:knon,cpl_index) = 0.0
     ENDIF
@@ -806,4 +836,8 @@
        cpl_tauy(ig,cpl_index) = cpl_tauy(ig,cpl_index) + &
             tauy(ig)        / REAL(nexca)     
+       cpl_sens_rain(ig,cpl_index) = cpl_sens_rain(ig,cpl_index) + &
+            sens_prec_liq(ig)      / REAL(nexca)
+       cpl_sens_snow(ig,cpl_index) = cpl_sens_snow(ig,cpl_index) + &
+            sens_prec_sol(ig)      / REAL(nexca)
        cpl_taumod(ig,cpl_index) = cpl_taumod(ig,cpl_index) + &
             SQRT ( taux(ig)*taux(ig)+tauy(ig)*tauy(ig) ) / REAL(nexca) 
@@ -839,4 +873,8 @@
           sum_error = sum_error + error
           ALLOCATE(cpl_windsp2D(nbp_lon,jj_nb), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_sens_rain2D(nbp_lon,jj_nb,2), stat=error)
+          sum_error = sum_error + error
+          ALLOCATE(cpl_sens_snow2D(nbp_lon,jj_nb,2), stat=error)
           sum_error = sum_error + error
           ALLOCATE(cpl_taumod2D(nbp_lon,jj_nb,2), stat=error)
@@ -889,4 +927,10 @@
 
        CALL gath2cpl(cpl_tauy(:,cpl_index), cpl_tauy2D(:,:,cpl_index), &
+            knon, knindex)
+
+       CALL gath2cpl(cpl_sens_rain(:,cpl_index), cpl_sens_rain2D(:,:,cpl_index), &
+            knon, knindex)
+
+       CALL gath2cpl(cpl_sens_snow(:,cpl_index), cpl_sens_snow2D(:,:,cpl_index), &
             knon, knindex)
 
@@ -1078,4 +1122,8 @@
     tab_flds(:,:,ids_nsfice) = cpl_nsol2D(:,:,2)
     tab_flds(:,:,ids_dflxdt) = cpl_fder2D(:,:,2)
+    tab_flds(:,:,ids_qraioc) = cpl_sens_rain2D(:,:,1)
+    tab_flds(:,:,ids_qsnooc) = cpl_sens_snow2D(:,:,1)
+    tab_flds(:,:,ids_qraiic) = cpl_sens_rain2D(:,:,2)
+    tab_flds(:,:,ids_qsnoic) = cpl_sens_snow2D(:,:,2)
     
     IF (version_ocean=='nemo') THEN
@@ -1279,4 +1327,7 @@
     DEALLOCATE(cpl_taux2D, cpl_tauy2D, cpl_windsp2D, cpl_taumod2D, stat=error )
     sum_error = sum_error + error
+    DEALLOCATE(cpl_sens_rain2D, cpl_sens_snow2D, stat=error)
+    sum_error = sum_error + error
+
     
     IF (carbon_cycle_cpl) THEN
Index: /LMDZ5/branches/testing/libf/phylmd/cv30_routines.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/cv30_routines.F90	(revision 2541)
+++ /LMDZ5/branches/testing/libf/phylmd/cv30_routines.F90	(revision 2542)
@@ -407,6 +407,5 @@
 
   DO i = 1, len !convect3
-    icb1(i) = max(icb(i), 2) !convect3
-    icb1(i) = min(icb(i), nl) !convect3
+    icb1(i) = min(max(icb(i), 2), nl)
     ! if icb is below LCL, start loop at ICB+1:
     ! (icbs est le premier niveau au-dessus du LCL)
